Status: Closed Start date: 2009-05-26

Priority: Normal Due date:  

Assignee: Toshi MARUYAMA % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version: 1.2.0   

Resolution: Fixed Affected version:  

Description

Currently the Mercurial plugin tries to read the file contents from the working directory (similar to the "staging area" in Git) instead of

the changesets themselves. This means when you try to view a file that's been removed from whatever changeset is checked out in

the working dir, it will be not found. Or, trying to view a certain version of a file that does exist in the working dir will just display

whatever version was checked out. This seems to be undesirable behavior. It'd be nice to use a null working directory similar to Git's

"bare" staging area.

Related issues:

Related to Redmine - Feature #4455: Mercurial overhaul Closed 2009-12-21

Has duplicate Redmine - Defect #6458: Mercurial View just a directory browser Closed 2010-09-21

Associated revisions

Revision 4629 - 2011-01-04 17:34 - Toshi MARUYAMA

scm: mercurial: refactor mercurial unit test.

lib unit test switches if repository exists.

move cat test from app to lib.

no need to run "hg update" in unit test (#3421).

Revision 4705 - 2011-01-13 13:05 - Toshi MARUYAMA

scm: mercurial: unit lib test for entries accept both of revision number and changeset id (#3724, #3421)

Revision 4856 - 2011-02-16 14:35 - Toshi MARUYAMA

scm: mercurial: rewrite MercurialAdapter#entries to show per-file change log and size (#3421, #4455).

Contributed by Yuya Nishihara.

Revision 4857 - 2011-02-16 16:43 - Toshi MARUYAMA

scm: mercurial: add identifier to entry.lastrev (#3724, #3421).

Revision 4858 - 2011-02-16 16:43 - Toshi MARUYAMA

scm: in repository tree, use find_changeset_by_name instead of changesets.find_by_revision (#3724, #3421).

Mercurial revision numbers are far too brittle.

Please see #6681 description.

Revision 4864 - 2011-02-18 05:13 - Toshi MARUYAMA

scm: mercurial: unit lib test for entries (#3421).

History

#1 - 2009-06-08 22:02 - Luke Hoersten

- Assignee set to Jean-Philippe Lang

- % Done changed from 0 to 10

A friend is working on a patch for me. Will submit it when we have it.

#2 - 2009-06-09 15:33 - Luke Hoersten
- File redmine-mercurial.patch added

- % Done changed from 10 to 50

That'd be great if we could get this patch reviewed and applied. Currently, Mercurial support is nothing more than reading the contents out of some

directory without this change. The change actually reads the repository itself.

#3 - 2009-07-29 08:19 - Jean-Philippe Lang

I'm not sure to understand the actual defect. Please include unit tests in your patch.

#4 - 2009-08-29 08:03 - Anil Gulecha

I see the same issue.. I pointed the repository for a project to a local clone of the mercurial repository.. and clicking on Repository takes a long while

(It's been about half an hour, and the repository page still wont open). This is the opensolaris kernel repository. If there's any information I can provide

about the setup, let me know.

#5 - 2009-09-17 23:29 - Luke Hoersten

Jean-Philippe Lang wrote:

I'm not sure to understand the actual defect. Please include unit tests in your patch.

 Do you understand what the staging area is in Git and why that is not the same thing as the repository? It's similar to that in Mercurial with the working

director. I'm not sure what unit tests you are looking for. It won't show anything without a Mercurial repo attached to it.

#6 - 2009-09-18 08:00 - Jean-Philippe Lang

Luke Hoersten wrote:

I'm not sure what unit tests you are looking for.

 A test that would fail with the actual code and pass with your patch.

It won't show anything without a Mercurial repo attached to it.

 Indeed. That's why there are test repositories (see doc/RUNNING_TESTS)

#7 - 2009-12-19 02:04 - Peter Fern

Umm, where are you getting this 'hg size' command from??  It doesn't exist on any version I have access to...

#8 - 2009-12-19 03:52 - Luke Hoersten

Peter Fern wrote:

Umm, where are you getting this 'hg size' command from??  It doesn't exist on any version I have access to...

 Ian (the guy who wrote the patch) wrote a Mercurial plugin to give size. If it's not there it should just show '-' I think.

#9 - 2009-12-19 04:07 - Peter Fern

Can you provide the mercurial plugin here?

#10 - 2009-12-19 04:20 - Luke Hoersten

- File size.py added

#11 - 2009-12-19 04:25 - Luke Hoersten

Peter Fern wrote:

I think you'll find that's incorrect, and looking at the patch, it doesn't modify the 'cat' method in any way other than to add a default identifier of

'tip'...

 Add a file to your Mercurial, commit, then delete and commit. If you try to view that file through Redmine, it will say it's not there because it's trying to

pull it from your working directory instead of the changeset itself.

#12 - 2009-12-19 04:27 - Peter Fern
In the mean time, I've added the size method, and a conditional in the model for my upcoming patchset to try the scm.size method and fall back to

accessing the filesystem if that returns nil.

#13 - 2009-12-19 04:38 - Peter Fern

Luke Hoersten wrote:

Add a file to your Mercurial, commit, then delete and commit. If you try to view that file through Redmine, it will say it's not there because it's

trying to pull it from your working directory instead of the changeset itself.

 That wasn't happening here, but there were some errors handling revisions, etc - the 'entry does not exist in the repository' error is generic, so it's

likely some other error was causing your problem, since the cat code currently in trunk works as expected.

Thanks for uploading the size extension, that's working great, and once I do some more testing, I'll get my patch up and link it to this issue for you to

test.

If you're still in touch with Ian, can you ask him why he used "glob:#{path}**" instead of "path:#{path}" in the 'entries' method for the patch attached

here?

#14 - 2009-12-19 04:40 - Peter Fern

Peter Fern wrote:

since the cat code currently in trunk works as expected.

 Actually, the problem was likely that mercurial wasn't getting passed a revision when calling cat, which is also fixed in my upcoming patchset

#15 - 2009-12-19 04:50 - Luke Hoersten

Peter Fern wrote:

Peter Fern wrote:

since the cat code currently in trunk works as expected.

 Actually, the problem was likely that mercurial wasn't getting passed a revision when calling cat, which is also fixed in my upcoming patchset

 Sounds very likely. I'll give it a try when you're ready.

Thanks for all the work!

#16 - 2009-12-21 01:31 - Peter Fern

I can't set issue relationships, but the patch is at #4455

#17 - 2010-03-11 11:30 - Toshi MARUYAMA

- File branch00.png added

- File branch01.png added

- % Done changed from 50 to 90

I finish unit and functional test of this feature.

http://github.com/marutosi/redmine/tree/hg-overhaul-0.9

http://github.com/marutosi/redmine/commit/4c8794959c06205ba133ea7cdda59e4984d75915

#18 - 2011-01-04 06:00 - Toshi MARUYAMA

- Category set to SCM

- Assignee changed from Jean-Philippe Lang to Toshi MARUYAMA

- % Done changed from 90 to 0

Note 17 is obsolete. Please see #4455.

#19 - 2011-02-18 05:14 - Toshi MARUYAMA

- Status changed from New to Closed

- Target version set to 1.2.0

- Resolution set to Fixed
Fixed in r4864.

Files

redmine-mercurial.patch 3.78 KB 2009-06-09 Luke Hoersten

size.py 1.33 KB 2009-12-19 Luke Hoersten

branch00.png 9.35 KB 2010-03-11 Toshi MARUYAMA

branch01.png 8.79 KB 2010-03-11 Toshi MARUYAMA
